			(* Dr Brain a perdu la tte : le programme	*)

type objet= Rien| Cerveau |Obstacle;;
type direction=N|S|E|O;;
type mobile={mx:int ref; my: int ref; mdir: direction ref};;
type action=Av|Td|Tg|Prend|Sous1|Sous2;;
 
(* les rponses aux nigmes *)
let p1= [|Sous1;Tg;Av;Tg;Av;Av;Td;Sous1|];;
let sp1=[|Sous2;Td;Sous2;Td;Sous2;Td;Sous2|];;
let ssp1=[|Av;Tg;Av;Td;Av;Prend;Av|];; 

let p2=[|Sous1;Sous2;Td;Sous2;Td;Sous2;Sous1|];;
let sp2=[|Sous2;Sous2;Sous2;Td;Sous2;Sous2;Sous2|];;
let ssp2=[|Av;Prend;Av;Prend;Av;Prend;Tg|];;

let p3=[|Sous2;Sous1;Sous1;Sous2;Sous2;Td;Sous1|];;
let sp3=[|Av;Prend;Av;Av;Prend;Td;Av|];;
let ssp3=[|Av;Av;Tg;Av;Td;Av;Prend|];;

(*  des fonctions qui vrifient qu'un sous-programme (resp un sous-sous-programme) ne triche pas	*)

let lov=list_of_vect;;	(* 	un alias	*)

let rec verifie_sp=function
	|[]->	true	|t::q->	((t !=Sous1) & (verifie_sp q));;

let rec verifie_ssp=function
	|[]->	true	|t::q->	((t !=Sous1) & (t !=Sous2) & (verifie_ssp q));;

(* on fera prcder l'application aux vecteurs de lov *)

(* confection de la liste d'action par remplacement *)
let remplace a A =
	let rec change= function
		|[]	->	[]
		|t::q	->	if (t=a) 
				then A@(change q)
				else t::(change q)
	in change;;

let rec cree_liste (p,sp,ssp)=
	let lp=lov p and lsp=lov sp and lssp=lov ssp 
	in remplace Sous2 lssp (remplace Sous1 lsp lp);;

(* crations: le terrain, les donnes  *)
(* dans le jeu d'origine, nb_col=11 et  nb_lig=7 *)
 
let nb_col=11;; let nb_lig =7;;	let nb_cerveaux=ref 10;;

(* terrain plein de Rien avec une muraille de sentinelles *)
let terrain=let ini=make_matrix (nb_col+2) (nb_lig+2) Rien in
	for i=0 to (nb_col+1) do 
		ini.(i).(0)<-Obstacle; ini.(i).(nb_lig+1)<-Obstacle done; 
	for j=0 to (nb_lig+1) do 
		ini.(0).(j)<-Obstacle; ini.(nb_col+1).(j)<-Obstacle done;
ini;;

(* ci-dessous on dfinit DrBrain lui mme (version virtuelle seulement) *)
let db={mx=ref 7;my= ref 5;mdir=ref E};;

(* les actions en mode texte *)
(* les affichages ne sont pas utilises par la suite, ils m'ont servi en cours de mise au point *)
let affiche_mobile {mx=x;my=y;mdir=dir}=
	print_newline();
	print_int !x;print_string"    ";
	print_int !y;print_string"     ";
	match !dir with 	|N->print_string"N" 
				|S->print_string"S" 
				|E->print_string"E"
				|O->print_string"O";
	print_string"    ";
	match terrain.(!x).(!y) with	|Rien	->	print_string"Rien"
					|Cerveau	->	print_string"Cerveau" 
					|Obstacle	->	print_string"Obstacle"
;;

let action_Av mob  =  begin
  		match !(mob.mdir) with
	|N	->	incr mob.my
	|S	->	decr mob.my
	|E	->	incr mob.mx
	|O	->	decr mob.mx
		end;
	affiche_mobile mob
;;

let action_Td mob  = match !(mob.mdir) with
	|N	->	mob.mdir:=E
	|S	-> 	mob.mdir:=O
	|E	-> 	mob.mdir:=S
	|O	-> 	mob.mdir:=N;;

let action_Tg mob  = match !(mob.mdir) with 
	|N	->	mob.mdir:=O
	|S	-> 	mob.mdir:=E
	|E	-> 	mob.mdir:=N
	|O	-> 	mob.mdir:=S;;
 
let action_Prend mob=let {mx=x;my=y;_}=mob in
	if terrain.(!x).(!y)=Cerveau then decr nb_cerveaux;
	terrain.(!x).(!y)<-Rien
;;

(* l'excution d'une liste d'ordres (mode texte) *)
(* ces commandes ne sont pas utilises par la suite, elles m'ont servi en cours de mise au point *)
let rec execute=function
	|Av::q		->	begin
					action_Av db;
					if terrain.(!(db.my)).(!(db.mx))=Obstacle 	
					then failwith "ouch"
					else execute q	;
				end
	|Td::q		->	action_Td db; execute q;
	|Tg::q		->	action_Tg db; execute q;
	|Prend::q	->	action_Prend db; 
				if !nb_cerveaux=0 then failwith "gagn" else execute q;
	|_		->	print_newline();failwith "liste puise";;

(* execute (cree_liste (p1,sp1,ssp1));; *)

(*  l'excution rcursive: voir fichier DB_rec *)
(*  le graphisme *)

(* 		 les chargements		 *)
directory "c:/option/modules/graphisme";;	(* <- A ADAPTER *)
load_object "Ini_gr";; #open "Ini_gr";;  #open "graphics";; 
open_graph "";;	(* initialisation, mode par dfaut *) 

(* 		 les utilitaires		 *)
(* la version de "attend" qui suit marche, mais ne permet pas de trs petites dures
let attend duree=
           let debut=sys__time() in
	while sys__time()-. debut < duree do done ;;	

j'ai donc fait un autre attend. Celui qui suit va, mais il dpend du processeur *)

let attend duree=let x= 23.456 and y= ref 1.2 in for k=1 to duree do y:=x*.x done;;

(* les fonctions comme virtuel_a_ecran sont dans Ini_gr *)
let iof=int_of_float;; let foi=float_of_int;;let pi=4.*.atan(1.);;
let vaex=virtuel_a_ecran_x  ;; let eavx=ecran_a_virtuel_x;;
let vaey=virtuel_a_ecran_y  ;; let eavy=ecran_a_virtuel_y;;
let range_vect p q=let v=make_vect (q-p+1) p in
	for k= (p+1) to q do v.(k)<-1+v.(k-1) done;v
;; 
 
(* 	 les objets  dessiner, monde virtuel        
	l'unit est la taille des carreaux de la grille 	*)
let flecheE=
[|(-0.2,-0.1);(0.2,-0.1);(0.2,-0.2);(0.4,0.0);(0.2,0.2);(0.2,0.1);(-0.2,0.1);(-0.2,-0.1)|];;
let flecheO=map_vect (fun (u,v)->(-.u,v)) flecheE;;
let flecheN=map_vect (fun (u,v)->(v,u)) flecheE;;
let flecheS=map_vect (fun (u,v)->(u,-.v)) flecheN;;

let bloc=[|(-0.4,0.4);(0.4,0.4);(0.4,-0.4);(-0.4,-0.4);(-0.4,0.4)|];;

let cerveau=map_vect (fun t->(0.4*.cos(2.*.pi*.(foi t)/.50.),0.4*.sin(2.*.pi*.(foi t)/.50.))) (range_vect 0 50);;

let croix=[|(0.,0.);(-0.2,0.);(0.2,0.);(0.,0.);(0.,0.2);(0.,-0.2);(0.,0.)|];;

(*  les objets  dessiner, monde de l' Ecran  *)
(* Virtuel A Ecran Vectoriel en X, en Y, en Point *)
let vaevx t= vaex t-vaex 0.;;	let vaevy t= vaey t-vaey 0.;;
let vaevp (u,v)= (vaevx u,vaevy v);;

(* let flecheEE=map_vect (fun (u,v)->((vaex u) - (vaex 0.),(vaey v) - (vaey 0.))) flecheE;; *)
let flecheEE=map_vect vaevp flecheE;;
let flecheOE=map_vect vaevp flecheO;; 
let flecheNE=map_vect vaevp flecheN;; 
let flecheSE=map_vect vaevp flecheS;; 

let blocE=map_vect vaevp bloc;; 

let cerveauE=map_vect vaevp cerveau;; 

let croixE=map_vect vaevp croix;; 

(* dcalages pour que l'affichage soit vers le centre de la fentre *)
let decale_x= - 250;;	let decale_y= - 200;;

let dessine_en (x,y) couleur contour= 
	set_color couleur;
	fill_poly (map_vect (fun (u,v)->(u+x+decale_x,v+y+decale_y)) contour);;

(* nombre d'intermdiaires dans un dplacement *)
let nbpas=10;;

let pose_en (x0,y0) couleur contour=
	dessine_en (vaex x0,vaey y0) couleur contour; attend 10000 ;;

let pose_centre (x,y) couleur contour=
	pose_en (foi x-.0.5, foi y-.0.5) couleur contour; attend 10000 ;;

let deplace_de_a (x0,y0) (x1,y1) couleur contour=
	let x=ref x0 and y=ref y0 
	and dx=(x1-.x0)/.(foi nbpas) and dy=(y1-.y0)/.(foi nbpas)  
	in
	for k= 1 to nbpas 	do 
		dessine_en (vaex !x,vaey !y) background contour;
		x:= !x+.dx; y:= !y+.dy; 
		dessine_en (vaex !x,vaey !y) couleur contour;attend 10000;
			done;
	dessine_en (vaex !x,vaey !y) background contour;
;; 

(* dessin initial de la grille qui sert de fond; j'ai laiss des trous entre les cases parce que je n'ai pas russi  faire fonctionner les get_image, blit_image et les  images transparentes de caml pour animer en restituant le fond *)

let grille nb_lig nb_col= 
	set_color red; 
	for c=0 to nb_col do
		for l=0 to nb_lig do
			pose_en (foi l,foi c) red croixE
	done;done;;

(*  les jeux de donnes  *)
(*    Ci-dessous la grille de "nigme n1"    *)
(* clear_graph();;  grille 11 7;; 
moveto 330 400;;  draw_string "nigme n1" ;;

map (fun (a,b)-> (pose_centre (a , b) green blocE)) [(7,6)];; 
map (fun (a,b)-> (terrain.(a).(b)<- Obstacle)) [(7,6)];; 

map (fun (a,b)-> (pose_centre ( a , b ) yellow cerveauE)) [(9,6);(11,4);(9,2);(7,4);(6,4);(2,4);(4,2);(4,6)];; 
map (fun (a,b)-> (terrain.(a).(b)<- Cerveau)) [(9,6);(11,4);(9,2);(7,4);(6,4);(2,4);(4,2);(4,6)];; 

pose_centre ( 7 , 5 ) blue flecheEE;;

let nb_cerveaux=ref 8;;
let db={mx=ref 7;my= ref 5;mdir=ref E};;
*)

(*  Ci-dessous la grille de "nigme n2"   *)
clear_graph();; grille 11 7;;
moveto 330 400;;  draw_string "nigme n2" ;;

map (fun (a,b)-> begin (pose_centre (a , b) green blocE); terrain.(a).(b)<-Obstacle 
	end ) [(1,1);(1,7);(6,3);(6,5);(10,2);(10,6)];; 
map (fun (a,b)-> begin (pose_centre (a , b) yellow cerveauE); terrain.(a).(b)<-Cerveau end )[(2,1);(3,1);(4,1);(5,1);(8,1);(9,1);(10,1);(11,1)];; 
map (fun (a,b)-> begin (pose_centre (a , b) yellow cerveauE  ); terrain.(a).(b)<-Cerveau  end )[(2,4);(3,4);(4,4);(5,4);(8,4);(9,4);(10,4);(11,4)];; 
map (fun (a,b)-> begin (pose_centre (a , b) yellow cerveauE); terrain.(a).(b)<-Cerveau end )[(2,7);(3,7);(4,7);(5,7);(8,7);(9,7);(10,7);(11,7)];; 
map (fun (a,b)-> begin (pose_centre (a , b) yellow cerveauE); terrain.(a).(b)<-Cerveau end )
[(3,1);(4,1);(9,1);(10,1);
(3,4);(4,4);(9,4);(10,4);
(3,7);(4,7);(9,7);(10,7);
(2,2);(5,2);(8,2);(11,2);
(2,3);(5,3);(8,3);(11,3);
(2,5);(5,5);(8,5);(11,5);
(2,6);(5,6);(8,6);(11,6);
(6,4);(7,4)];; 

pose_centre (11 , 4) blue flecheNE;;

let nb_cerveaux=ref 42;;
let db={mx=ref 11;my= ref 4;mdir=ref N};;
(**)

(* Ci-dessous la grille de "nigme n3" *)
(* clear_graph();; grille 11 7;;
moveto 330 400;;  draw_string "nigme n3" ;;

map (fun (a,b)-> begin (pose_centre (a , b) green blocE); terrain.(a).(b)<-Obstacle 
end)
[(1,3);(1,7);(2,6);(4,2);(4,4);(6,2);(7,5);(8,1);(8,3);(8,4);(8,7);(9,4);(11,1);(11,6)];; 
map (fun (a,b)-> begin (pose_centre (a , b) yellow cerveauE); terrain.(a).(b)<-Cerveau end )[(3,1);(5,1);(6,1);(3,3);(3,5);(7,6);(10,4);(10,6);(10,7)];; 

pose_centre (9 , 2) blue flecheOE;;

let nb_cerveaux=ref 9;;
let db={mx=ref 9;my= ref 2;mdir=ref O};;
*)

(*   les actions graphiques    *) 
let deplace_graph_de_a (x0,y0) (x1,y1) couleur contour=
deplace_de_a (foi x0 -.0.5,foi  y0 -.0.5) (foi x1 -.0.5,foi y1 -.0.5) couleur contour;;
  
let action_graph_Av mob  =  begin
  		match !(mob.mdir) with
	|N	->	let u= !(mob.mx) and v= !(mob.my) in 
			begin 
				deplace_graph_de_a (u,v) (u,v+1) blue flecheNE;
				incr mob.my;
			end
	|S	->	let u= !(mob.mx) and v= !(mob.my) in 
			begin
				deplace_graph_de_a (u,v) (u,v-1) blue flecheSE;
				decr mob.my
			end
	|E	->	let u= !(mob.mx) and v= !(mob.my) in 
			begin
				deplace_graph_de_a (u,v) (u+1,v) blue flecheEE;
				incr mob.mx
			end
	|O	->	let u= !(mob.mx) and v= !(mob.my) in 
			begin
				deplace_graph_de_a (u,v) (u-1,v) blue flecheOE;
				decr mob.mx
			end
		end;
	affiche_mobile mob
;;

let action_graph_Td mob  = match !(mob.mdir) with
	|N	->	mob.mdir:=E
	|S	-> 	mob.mdir:=O
	|E	-> 	mob.mdir:=S
	|O	-> 	mob.mdir:=N;;

let action_graph_Tg mob  = match !(mob.mdir) with 
	|N	->	mob.mdir:=O
	|S	-> 	mob.mdir:=E
	|E	-> 	mob.mdir:=N
	|O	-> 	mob.mdir:=S;;

(* dfaut: l'effacement du cerveau efface la flche, d'o le clignotement *) 
let action_graph_Prend mob=let {mx=x;my=y;_}=mob in
	if terrain.(!x).(!y)=Cerveau
	then begin
		decr nb_cerveaux;
		pose_centre (!(mob.mx),!(mob.my)) background cerveauE;
		terrain.(!x).(!y)<-Rien
	        end
;;

(*  l'excution graphique d'une liste d'ordres  *)
let rec execute_graph=function
	|Av::q		->	begin
					action_graph_Av db;
					if terrain.(!(db.mx)).(!(db.my))=Obstacle 	
					then failwith "ouch"
					else  execute_graph q	;
				end
	|Td::q		->	action_graph_Td db;  execute_graph q;
	|Tg::q		->	action_graph_Tg db;  execute_graph q;
	|Prend::q	->	action_graph_Prend db; 
			if !nb_cerveaux=0 then failwith "gagn" else  execute_graph q;
	|_		->	print_newline();failwith "liste puise";;

(* Les commandes qui suivent sont faites pour succder  la cration de la grille d'nigme correspondante *)
 
(* execute_graph (cree_liste (p1,sp1,ssp1));; *)

(* execute_graph (cree_liste (p2,sp2,ssp2));; *)

(* execute_graph (cree_liste (p3,sp3,ssp3));; *)

(*  Notes d'utilisation:
Pour une raison non encore comprise:
-> quand on charge tout, l'execution est sans problme
-> quand on recharge un autre nonc, cela marche ... parfois 	
-> bien sr si on recharge tout cela marche
	Qu'ai-je oubli de faire  la fin?
*)

(* ce qui reste  faire:
 un interface utilisateur avec

aide  l'entre des donnes 
aide  l'entree des commandes

La rcursion est traite dans l'autre fichier: DB_rec.tex
l'entre interactive sera traite dans l'autre fichier: DB_ldc.tex
*)
