				(*	bon_ABCD.ml	*)

(* la vrification de l'tat tas se fait par enregistrement des numros des Noeuds et Feuilles dans une liste, suivi d'un tri NON! d'un hachage direct *)

type 'a tas= 	Nil	
		|Feuille of 'a 	
		|Noeud of  'a tas*'a*'a tas;; 

(* 	quelques crations d'arbres pour tester 	*)
let a=Nil;;
let a0=Feuille 0;;
let a1=Noeud (a0,1,a0);;
let a2=Noeud (a1,2,a1);;
let a3=Noeud (a2,3,a2);;
let a4=Noeud (a3,4,a3);;

let enregistre arbre=
	let rec boulot liste valeur tree=match tree with
		|Nil			->	[0]
		|Feuille _		->	(valeur::liste)
		|Noeud (fg,p,fd)	->	let vfg = boulot liste (2*valeur) fg
						and vfd = boulot liste (2*valeur+1) fd
						in vfg@(valeur::vfd)
	in boulot [] 1 arbre;;

let hache liste=
	let tableau=make_vect (list_length liste+1) true in
	let rec vide=fun
		|[]	->	"gagn, c'est un tas"
		|(t::q)	->	if (t>=vect_length tableau) or (not tableau.(t))
				then "perdu, ce n'est pas un tas"
				else begin tableau.(t)<-false; vide q end
in vide liste;;

(* les comparaisons incessantes  vect_length tableau sont idiotes, il doit y avoir un moyen de rattrapper les failwith *)

let valeur = function
	|Nil			->	failwith "pas de valeur"
	|Feuille f		-> 	f
	|Noeud (_,n,_)	->	n
;;

let bon_ABCD ordre arbre=
	let rec verifie 	= function
		|Nil			->	true
		|Feuille f		->	true
		|Noeud (fg,n,fd)	->	((fg=Nil) or ordre (valeur fg) n) 	& 
						((fd=Nil) or ordre (valeur fd) n) 	& 
						(verifie fg) 			& 						(verifie fd)	
	in verifie arbre;;


bon_ABCD (prefix <=) a4;;
- : bool = true